# [auth.rxbn.de](https://auth.rxbn.de) - Single sign-on (SSO) Service

Single sign-on authentication service for rxbn.de services

# Environment variables
- __*DB_URL*__ := [MongoDB Connection URI String Format](https://docs.mongodb.com/manual/reference/connection-string/), ex.: mongodb://mongoDBUser:mongoDBPassword@localhost:27017/admin
- __*DB_NAME*__ := MongoDB Database, ex.: authRxbn
- __*SESSION_KEY*__ := SessionKey to encrypt sessions
- __*COOKIE_KEY*__ := CookieKey to encrypt cookies
- __*PROMETHEUS_USER*__ := PrometheusUser for basic authentication on prometheus endpoints, ex.: test
- __*PROMETHEUS_PW*__ := PrometheusPassword for basic authentication on prometheus endpoints, ex.: test

# start server
## regular
```sh
$ DB_URL="mongodb://user:pass@ip:port/authdb" DB_NAME="authRxbn" SESSION_KEY="32byteHexString" COOKIE_KEY="32byteHexString" PROMETHEUS_USER="authUsername" PROMETHEUS_PW="authPassword" node app.js
```
## debug
```sh
$ DB_URL="mongodb://user:pass@ip:port/authdb" DB_NAME="authRxbn" SESSION_KEY="32byteHexString" COOKIE_KEY="32byteHexString" PROMETHEUS_USER="authUsername" PROMETHEUS_PW="authPassword" NODE_ENV=debug node app.js
```
